﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Runtime.InteropServices;

namespace CosmoZ
{
	public enum MAGIC_NUMBER
	{
		CSZRAW = 0x20c5, // バイナリダンプでCS20と読める。CSZ-0の意。生データ
		CSZPLL = 0x21c5, // バイナリダンプでCS21と読める。CSZ-1の意。低レート　パルスデータ
		CSZPLH = 0x22c5, //　バイナリダンプでCS22と読める。CSZ-2の意。高レート　パルスデータ
		CSZMCA = 0x23c5, //　バイナリダンプでCS23と読める。CSZ-3の意。MCAデータ
		CSZFFT = 0x2fc5, //　バイナリダンプでCS2Fと読める。CSZ-Fの意。FFTデータ
		CHUNKRAW = 0xc0c5 //　バイナリダンプでCS2Fと読める。CSC-0の意
	};

	[StructLayout(LayoutKind.Sequential, Pack = 4)]
	public unsafe struct FILEHEAD_CSZRAW
	{
		public ushort magic_number;
		public fixed sbyte magic_word[3];
		public byte pad1;
		public byte pad2;
		public byte n_boards;
		public UInt32 start_unixtime;
		public UInt32 end_unixtime;
		public UInt32 chmask;
		public UInt32 iteration;
		public UInt32 triginfo;
		public UInt32 adccommand;
		public fixed byte original_name[32];
		public fixed byte comment[64];
		public fixed ushort adc_offset[32];
		public fixed ushort adc_mult[32];
		public fixed ushort adc_delay[32];
		public fixed UInt32 adc_trig[32];
		public int extdecimation;
	};

	[StructLayout(LayoutKind.Sequential, Pack = 4)]
	public unsafe struct CHUNKHEAD_CSZRAW
	{
		public UInt16 magic_number;
		public UInt16 time48_low;
		public UInt16 time48_mid;
		public UInt16 time48_high;
		public UInt32 length;
		public UInt16 xadc1;
		public UInt16 xadc2;
		public UInt16 xadc3;
		public UInt16 xadc4;
		public fixed UInt16 pedestal[32];
		public UInt32 gps_time;
		public UInt32 gps_10ns;
		public UInt32 gps_maxcount;
		public UInt32 captaddr; // キャプチャ開始アドレス
	};

	[StructLayout(LayoutKind.Sequential, Pack = 4)]
	public unsafe struct CHUNKHEAD_CSZPLS
	{
		public UInt16 magic_number;
		public UInt16 time48_low;
		public UInt16 time48_mid;
		public UInt16 time48_high;
		public UInt32 length;
		public UInt16 xadc1;
		public UInt16 xadc2;
		public UInt16 xadc3;
		public UInt16 xadc4;
		public fixed UInt16 pedestal[32];
		public UInt16 max_x;
		public UInt16 min_y;
		public UInt16 max_y;
		public UInt32 eventcount;
	};

	public unsafe struct EVENTHEAD
	{
		public ushort header;
		public ushort datalen;
		public UInt64 start_time;
		public ushort pulse_high;
		public UInt32 pulse_sum;
		public ushort pedestal;
		public ushort triglen;
	};
}
