﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;
using System.Threading.Tasks;
using System.IO;

namespace CosmoZ
{
	public partial class CosmoZWrapper
	{
		//! ドライバをオープンし、その他の雑多な初期化処理を行う。
		[DllImport("libcsz.dll")]
		protected static extern bool csz_open(INTERFACE_PORT ifport, String target);

		//! インタフェースのタイプを返す
		[DllImport("libcsz.dll")]
		protected static extern INTERFACE_PORT csz_get_interface_type();

		//! リモートサーバのバージョンを返す
		[DllImport("libcsz.dll")]
		protected static extern UInt32 csz_remote_version();

		//! ファームウェアのバージョンを返す
		[DllImport("libcsz.dll")]
		protected static extern UInt32 csz_firmware_version();

		//! ファームウェアの日付を返す
		[DllImport("libcsz.dll")]
		protected static extern UInt32 csz_firmware_date();

		//! ドライバのバージョンを返す
		[DllImport("libcsz.dll")]
		protected static extern UInt32 csz_driver_version();

		//! FPGAのバージョンを返す
		[DllImport("libcsz.dll")]
		protected static extern UInt32 csz_fpga_version();

		//! ドライバをクローズし、その他の雑多なメモリの開放や環境の復元を行います。
		//! CosmoZライブラリをクローズする関数
		[DllImport("libcsz.dll")]
		protected static extern void csz_close();

		//! 48bitタイムスタンプの値を返す
		//! FPGAが起動してからの時間を10ns単位で計った値
		[DllImport("libcsz.dll")]
		protected static extern UInt64 csz_time48();

		[DllImport("libcsz.dll")]
		protected static extern double csz_xadc_tempe();
		[DllImport("libcsz.dll")]
		protected static extern float csz_xadc_vccint();
		[DllImport("libcsz.dll")]
		protected static extern float csz_xadc_vccaux();
		[DllImport("libcsz.dll")]
		protected static extern float csz_xadc_vccddro();

		[DllImport("libcsz.dll")]
		protected static extern UInt32 csz_reg_read(Int32 regnum);

		[DllImport("libcsz.dll")]
		protected static extern bool csz_reg_write(Int32 regnum, UInt32 val);

		[DllImport("libcsz.dll")]
		protected static extern Int32 csz_mem_read(UInt32 addr, Int32 len, IntPtr buf);

		[DllImport("libcsz.dll")]
		protected static extern Int32 csz_mem_write(UInt32 addr, Int32 len, IntPtr buf);
		[DllImport("libcsz.dll")]
		protected static extern UInt32 csz_adc_val(int ch);
		[DllImport("libcsz.dll")]
		protected static extern void csz_adc_reset();
		[DllImport("libcsz.dll")]
		protected static extern bool csz_adc_freq(Int32 freq);
		[DllImport("libcsz.dll")]
		protected static extern Int32 csz_adc_getfreq();

		[DllImport("libcsz.dll")]
		protected static extern void csz_adc_testmode(bool on, int option);

		[DllImport("libcsz.dll")]
		protected static extern bool csz_adc_is_testmode();

		[DllImport("libcsz.dll")]
		protected static extern Int32 csz_adc_maxch();

		[DllImport("libcsz.dll")]
		protected static extern void csz_adc_regdump();

		[DllImport("libcsz.dll")]
		protected static extern void csz_adc_regwr(ushort addr, byte data);

		[DllImport("libcsz.dll")]
		protected static extern ushort csz_adc_regrd(ushort addr);
		[DllImport("libcsz.dll")]

		protected static extern CAPTURE_INFO csz_capture_execute(UInt32 chmask, Int32 length, CAPTURE_TRIGGER type, Int32 maxseq);
		[DllImport("libcsz.dll")]
		protected static extern void csz_capture_abort();

		[DllImport("libcsz.dll")]
		protected static extern CAPTURE_STATUS csz_capture_status();

		[DllImport("libcsz.dll")]
		protected static extern void csz_capture_timeout(int ms);

		[DllImport("libcsz.dll")]
		protected static extern int csz_capture_get_timeout();

		[DllImport("libcsz.dll")]
		protected static extern void csz_capture_datacopy(CAPTURE_INFO info, Int32 ch, IntPtr result);

		[DllImport("libcsz.dll")]
		protected unsafe static extern void csz_adc_getinfo(out IntPtr cinfo);

		[DllImport("libcsz.dll")]
		protected static extern bool csz_pretrig_set(int pre);

		[DllImport("libcsz.dll")]
		protected static extern void csz_pretrig_type(bool extend);

		[DllImport("libcsz.dll")]
		protected static extern int csz_pretrig_get();

		[DllImport("libcsz.dll")]
		protected static extern int csz_pretrig_max();

		[DllImport("libcsz.dll")]
		protected static extern bool csz_posttrig_set(int pre);

		[DllImport("libcsz.dll")]
		protected static extern int csz_posttrig_get();

		[DllImport("libcsz.dll")]
		protected static extern void csz_posttrig_fixed(bool fix);

		[DllImport("libcsz.dll")]
		protected static extern bool csz_posttrig_is_fixed();

		public delegate void CallbackDisconnected();
		[DllImport("libcsz.dll")]
		protected static extern void csz_disconnected_from_target(CallbackDisconnected callback);

		[DllImport("libcsz.dll")]
		protected static extern void csz_regist_process_thread(CallbackProcessThread callback);

		[DllImport("libcsz.dll")]
		protected static extern void csz_trig_ortrig(bool ortrig);

		[DllImport("libcsz.dll")]
		protected static extern bool csz_trig_is_ortrig();

		[DllImport("libcsz.dll")]
		protected static extern bool csz_trig_set(int ch, TRIGTYPE type, int val);

		[DllImport("libcsz.dll")]
		protected static extern bool csz_trig_set_voltage(int ch, TRIGTYPE type, double voltage);

		[DllImport("libcsz.dll")]
		protected static extern TRIGTYPE csz_trig_gettype(int ch);
		[DllImport("libcsz.dll")]
		protected static extern int csz_trig_getadcval(int ch);
		[DllImport("libcsz.dll")]
		protected static extern double csz_trig_getvoltage(int ch);
		[DllImport("libcsz.dll")]
		protected static extern string csz_trig_tostr(TRIGTYPE type);
		[DllImport("libcsz.dll")]
		protected static extern int csz_trig_rate(int ch);
		[DllImport("libcsz.dll")]
		protected static extern int csz_trig_pulseheight(int ch);
		[DllImport("libcsz.dll")]
		protected static extern int csz_trig_pedestal(int ch);

		[DllImport("libcsz.dll")]
		protected static extern void csz_trig_set_gcap(int ch, bool enable);

		[DllImport("libcsz.dll")]
		protected static extern bool csz_trig_get_gcap(int ch);
		[DllImport("libcsz.dll")]
		protected static extern string csz_exttrig_tostr(EXTTRIGTYPE type);
		[DllImport("libcsz.dll")]
		protected static extern EXTTRIGTYPE csz_exttrig_get(int extch);

		[DllImport("libcsz.dll")]
		protected static extern bool csz_exttrig_set(int extch, EXTTRIGTYPE type);

		[DllImport("libcsz.dll")]
		protected static extern bool csz_gps_time(IntPtr gps_time, IntPtr gps_10ns, IntPtr gps_maxcount);

		[DllImport("libcsz.dll")]
		protected static extern void csz_gps_settime(UInt32 time);

		[DllImport("libcsz.dll")]
		protected static extern int csz_remote_clkphase(int shift);

		[DllImport("libcsz.dll")]
		protected static extern void csz_get_mcaheader(out MCAInfo mcainfo);

		[DllImport("libcsz.dll")]
		protected static extern void csz_get_mcadata(IntPtr buf, int len);

		[DllImport("libcsz.dll")]
		protected static extern void csz_mca_start(UInt32 goaltime, bool elapsed_mode, bool use_upp);
		[DllImport("libcsz.dll")]
		protected static extern void csz_mca_stop();
		[DllImport("libcsz.dll")]
		protected static extern void csz_mca_clear();

		[DllImport("libcsz.dll")]
		protected static extern CosmoZStatus2 remote_get_status();

		[DllImport("libcsz.dll")]
		protected static extern UPPStatus csz_get_upp_status();

		[DllImport("libcsz.dll")]
		protected static extern void csz_evcap_start(int length, EVENTCAP_MODE mode, UInt32 chmask);

		[DllImport("libcsz.dll")]
		protected static extern CAPTURE_STATUS csz_evcap_status(out EVCAP_STATUS evstat);

		[DllImport("libcsz.dll")]
		protected static extern void csz_evcap_getdata();
	}
}
