﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;
using System.Threading.Tasks;
using System.IO;

namespace CosmoZ
{
	// lolevel.csの関数は、いずれ外から見えなくなります

	public partial class CosmoZWrapper
	{
		public bool open(INTERFACE_PORT ifport, String target)
		{
			if(csz_open(ifport, target))
			{
//				self = this;
				return true;
			}
			//			self = null;
			return false;
		}

		public void close()
		{
			csz_close();
//			self = null;
		}

		public double xadc_tempe()
		{
			return csz_xadc_tempe();
		}

		public UInt32 remote_version()
		{
			return csz_remote_version();
		}

		public UInt32 firmware_version()
		{
			return csz_firmware_version();
		}

		public UInt32 firmware_date()
		{
			return csz_firmware_date();
		}

		public UInt32 driver_version()
		{
			return csz_driver_version();
		}

		public UInt32 fpga_version()
		{
			return csz_fpga_version();
		}

		public UInt64 time48()
		{
			return csz_time48();
		}

		public UInt32 reg_read(Int32 regnum)
		{
			return csz_reg_read(regnum);
		}

		public bool reg_write(Int32 regnum, UInt32 val)
		{
			return csz_reg_write(regnum, val);
		}

		public Int32 mem_read(UInt32 addr, Int32 len, byte[] data)
		{
			int trlen = (int)((data.Length + 7) / 8) * 8; // 8の単位で切り上げる
			int ret = 0;
			unsafe
			{
				fixed (byte* p = data)
				{
					IntPtr ptr = (IntPtr)p;
					ret = csz_mem_read(addr, trlen, ptr);
				}

			}
			return ret;
		}

		public Int32 mem_write(UInt32 addr, Int32 len, byte[] data)
		{
			// unsafeなやり方
			int trlen = (int)((data.Length + 7) / 8) * 8; // 8の単位で切り上げる
			int ret; // 戻り値
			unsafe
			{
				fixed (byte* p = data)
				{
					IntPtr ptr = (IntPtr)p;
					ret = csz_mem_write(addr, trlen, ptr);
				}
			}
			return ret;
		}

		public UInt32 adc_val(Int32 ch)
		{
			return csz_adc_val(ch);
		}

		public void adc_reset()
		{
			csz_adc_reset();
		}

		public bool adc_freq(Int32 freq)
		{
			return csz_adc_freq(freq);
		}

		public Int32 adc_getfreq()
		{
			return csz_adc_getfreq();
		}

		public Int32 adc_maxch()
		{
			return csz_adc_maxch();
		}

		//        [DllImport("libcsz.dll")]
		//      protected static extern void csz_adc_enumerate(int* adcnum, char partnum[8][32]);




		public CAPTURE_INFO capture_execute(UInt32 chmask, Int32 length, CAPTURE_TRIGGER type, Int32 maxseq)
		{
			return csz_capture_execute(chmask, length, type, maxseq);
		}

		public void capture_abort()
		{
			csz_capture_abort();
		}

		public void capture_timeout(int ms)
		{
			csz_capture_timeout(ms);
		}

		public int capture_get_timeout()
		{
			return csz_capture_get_timeout();
		}


		public void capture_datacopy(CAPTURE_INFO info, Int32 ch, ushort[] result)
		{
			unsafe
			{
				fixed (ushort* p = result)
				{
					IntPtr ptr = (IntPtr)p;
					csz_capture_datacopy(info, ch, ptr);
				}
			}
		}

		public void adc_getinfo(out ADC_INFO info)
		{
			ADC_INFO tmp = new ADC_INFO();

			IntPtr cinfo = Marshal.AllocCoTaskMem(Marshal.SizeOf(tmp));
			Marshal.StructureToPtr(tmp, cinfo, false);
			csz_adc_getinfo(out cinfo);
			Marshal.FreeCoTaskMem(cinfo);
			info = tmp;
		}

		public bool pretrig_set(int pre)
		{
			return csz_pretrig_set(pre);
		}

		public void pretrig_type(bool extend)
		{
			csz_pretrig_type(extend);
		}

		public int pretrig_get()
		{
			return csz_pretrig_get();
		}

		public int pretrig_max()
		{
			return csz_pretrig_max();
		}

		public bool posttrig_set(int pre)
		{
			return csz_posttrig_set(pre);
		}

		public int posttrig_get()
		{
			return csz_posttrig_get();
		}

		public void posttrig_fixed(bool fix)
		{
			csz_posttrig_fixed(fix);
		}

		public bool posttrig_is_fixed()
		{
			return csz_posttrig_is_fixed();
		}

		public void disconnected_from_target(CallbackDisconnected callback)
		{
			csz_disconnected_from_target(callback);
		}

		public delegate void CallbackProcessThread();
		public void regist_process_thread(CallbackProcessThread callback)
		{
			csz_regist_process_thread(callback);
		}

		public void trig_ortrig(bool ortrig)
		{
			csz_trig_ortrig(ortrig);
		}

		public bool trig_is_ortrig()
		{
			return csz_trig_is_ortrig();
		}

		public bool trig_set(int ch, TRIGTYPE type, int val)
		{
			return csz_trig_set(ch, type, val);
		}

		public bool trig_set_voltage(int ch, TRIGTYPE type, double voltage)
		{
			return csz_trig_set_voltage(ch, type, voltage);
		}

		public TRIGTYPE trig_gettype(int ch)
		{
			return csz_trig_gettype(ch);
		}

		public int trig_getadcval(int ch)
		{
			return csz_trig_getadcval(ch);
		}

		public double trig_getvoltage(int ch)
		{
			return csz_trig_getvoltage(ch);
		}

		public string trig_tostr(TRIGTYPE type)
		{
			return csz_trig_tostr(type);
		}

		public int trig_rate(int ch)
		{
			return csz_trig_rate(ch);
		}

		public int trig_pulseheight(int ch)
		{
			return csz_trig_pulseheight(ch);
		}

		public int trig_pedestal(int ch)
		{
			return csz_trig_pedestal(ch);
		}
		public void trig_set_gcap(int ch, bool enable)
		{
			csz_trig_set_gcap(ch, enable);
		}

		public bool trig_get_gcap(int ch)
		{
			return csz_trig_get_gcap(ch);
		}

		public string exttrig_tostr(EXTTRIGTYPE type)
		{
			return csz_exttrig_tostr(type);
		}

		public EXTTRIGTYPE exttrig_get(int extch)
		{
			return csz_exttrig_get(extch);
		}

		public bool exttrig_set(int extch, EXTTRIGTYPE type)
		{
			return csz_exttrig_set(extch, type);
		}

		//bool gps_get_time(out UInt32 gps_time, out UInt32 gps_10ns, out UInt32 gps_maxcount)
		//{
		//	UInt32 a, b, c;
		//	Boolean stat;
		//	stat = csz_gps_time(out a, out b, out c);
		//	return stat;
		//}

		void gps_settime(UInt32 time)
		{
			csz_gps_settime(time);
		}

		public int remote_clkphase(int shift)
		{
			return csz_remote_clkphase(shift);
		}
	}
}
