﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Threading;

namespace CosmoZ
{
	internal class Program
	{
		static void Main(string[] args)
		{
			if(args.Length < 1)
			{
				Console.WriteLine("Usage:csztest.exe <hostname>");
				return;
			}
			CosmoZWrapper csz = new CosmoZWrapper();
			if(!csz.open(INTERFACE_PORT.INTERFACE_TCPIP, args[0]))
			{
				Console.WriteLine($"Can not connect to {args[0]}");
				return;
			}

            csz.adc_freq(80);
            Thread.Sleep(100); // ADC周波数を変えた場合は30ms以上のWaitが必要

            const int DATASIZE = 10;
            CAPTURE_INFO info;
            info = csz.capture_execute(0xff, DATASIZE, CAPTURE_TRIGGER.CAPTRIG_AUTO, 1);
            if (info.result != CAPTURE_RESULT.CAPRESULT_SUCCESS)
            {
                Console.WriteLine("キャプチャエラー");
                csz.close();
                return;
            }
            Console.WriteLine("time[ns]\tCH1\tCH2\tCH3\tCH4");
            UInt16[] data1 = new UInt16[DATASIZE];
            UInt16[] data2 = new UInt16[DATASIZE];
            UInt16[] data3 = new UInt16[DATASIZE];
            UInt16[] data4 = new UInt16[DATASIZE];
            csz.capture_datacopy(info, 1, data1); // CH1を読む
            csz.capture_datacopy(info, 2, data2); // CH2を読む
            csz.capture_datacopy(info, 3, data3); // CH3を読む
            csz.capture_datacopy(info, 4, data4); // CH4を読む
            for (int i = 0; i < DATASIZE; i++)
            {
                Console.WriteLine($"{i * 12.5:f1}\t{data1[i]}\t{data2[i]}\t{data3[i]}\t{data4[i]}");
            }
            csz.close();
			Console.WriteLine("Hit any key");
			Console.ReadKey();
		}
	}
}
